<script>
import { ref, computed, onMounted, reactive } from "vue";
import store from "@/store"
import useValidate from "@vuelidate/core";
import { required, email, minLength, sameAs, helpers } from "@vuelidate/validators";
import { HTTP } from "@/components/common/HttpCommon";

import Loading from '@/components/item/Loading.vue';
import UserForm from '@/components/forms/UserForm.vue'
export default {
  components: { Loading, UserForm },
  name: 'UsersView',
  props: {
  },
  data() {
    return {
      formTitle: null,
      showForm : false,
      modalShow: false,
      formData: null
    }
  },
  setup() {
    const data = ref(null);
    const size = ref(0);
    const loading = ref(false);
    const error = ref(null);
    const state = reactive({
      name : '',
      email : '',
      username : '',
      password : {
        confirm: '',
        password: ''
      },
      agree : false
    });
    const rules = computed(() => {
      return {
        name : { required },
        email : { required, email },
        username : { required },
        password : {
          password : {required },
          confirm : { required, sameAs : sameAs( state.password.password ) }
        },
        agree : { sameAs : sameAs ( true ) }
      }
    });
    const v$ = useValidate(rules, state)
    async function fetchData() {
      loading.value = true;
      const result = await HTTP.get(`users`).then(response => {
        data.value = response.data.data.content
        size.value = response.data.data.content.length
      })
          .catch(e => {
            console.log(e)
          })
      loading.value = false;
    }
    function deleteData(id){

    }

    onMounted(() => {
      fetchData();
    });

    return {
      data,
      size,
      loading,
      error,
      state,
      v$,
      deleteData,
      fetchData
    };
  },methods: {
    doSignIn() {
      localStorage.signup = !store.state.signup
      store.commit('togleSignUp')
      location.reload()
    },
    formModalDone() {
      this.modalShow = !this.modalShow
      this.$nextTick().then(() => {
        this.fetchData()
      })
    },
    showModalUser(title, index) {
      this.formTitle = title
      if(title != 'Add User'){
        this.formData = this.data[index]
      }else{
        this.formData = null
      }
      this.$nextTick().then(() => {
        if(title == 'Delete User'){
          this.deleteData(this.formData.id)
        }else{
          this.modalShow = !this.modalShow
        }
      });
    }
  }
}
</script>
<template>
  <div class="container-fluid">
    <Loading v-if="loading" />
    <div class="row" v-if="!loading">
      <div class="col-lg-12" v-if="modalShow">
        <UserForm v-if="modalShow" @close-modal="modalShow = !modalShow" @form-modal-done="formModalDone" :title="formTitle" :data="formData" />
      </div>
      <div class="col-lg-12" v-if="!modalShow">
        <div class="d-flex flex-wrap flex-wrap align-items-center justify-content-between mb-4">
          <div>
            <h4 class="mb-3">User List</h4>
            <!-- <p class="mb-0">The product list effectively dictates product presentation and provides space<br> to list your products and offering in the most appealing way.</p> -->
          </div>
          <a href="#add-user" class="btn btn-primary add-list" @click="showModalUser('Add User')" ><i class="ri-add-fill"></i>Add User</a>
        </div>
      </div>
      <div class="col-lg-12" v-if="!modalShow">
        <div class="table-responsive rounded mb-3">
          <table class="data-tables table mb-0 tbl-server-info">
            <thead class="bg-white text-uppercase">
            <tr class="ligth ligth-data">
              <th>Name</th>
              <th>Username</th>
              <th>Email</th>
              <th>Mobile</th>
              <th>User Role</th>
              <th>User Type</th>
              <th>Action</th>
            </tr>
            </thead>
            <tbody class="ligth-body">
            <tr v-if="data && size > 0" v-for="(item, index) in data">
              <td>
                <div class="d-flex align-items-left">
                  <img src="../assets/images/table/product/01.jpg" class="img-fluid rounded avatar-50 mr-3" alt="image">
                  <div>
                    {{item.name}}
                    <p class="mb-0"><small>{{item.description}}</small></p>
                  </div>
                </div>
              </td>
              <td>{{item.username}}</td>
              <td>{{item.email}}</td>
              <td>{{item.mobile}}</td>
              <td>{{item.userRole}}</td>
              <td>{{item.userType}}</td>
              <td>
                <div class="d-flex align-items-left list-action">
                  <a class="badge badge-info mr-2" :href="'#view-user-' + item.id" v-b-modal.modal-1 @click="showModalUser('View Detail User', index)" ><i class="ri-eye-line mr-0"></i></a>
                  <a class="badge bg-success mr-2" :href="'#edit-user-' + item.id" v-b-modal.modal-1 @click="showModalUser('Edit User', index)" ><i class="ri-pencil-line mr-0"></i></a>
                  <a class="badge bg-warning mr-2" :href="'#delete-user-' + item.id" v-b-modal.modal-1 @click="showModalUser('Delete User')" ><i class="ri-delete-bin-line mr-0"></i></a>
                </div>
              </td>
            </tr>
            <tr v-if="size <= 0">
              <td colspan="7"><i><strong> No Data Found </strong></i></td>
            </tr>
            </tbody>
          </table>
        </div>
      </div>
    </div>
    <!-- Page end  -->
  </div>
  <!-- Modal Edit -->
  <div class="modal fade" id="edit-note" tabindex="-1" role="dialog" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document">
      <div class="modal-content">
        <div class="modal-body">
          <div class="popup text-left">
            <div class="media align-items-top justify-content-between">
              <h3 class="mb-3">Users</h3>
              <div class="btn-cancel p-0" data-dismiss="modal"><i class="las la-times"></i></div>
            </div>
            <div class="content edit-notes">
              <div class="card card-transparent card-block card-stretch event-note mb-0">
                <div class="card-body px-0 bukmark">
                  <div class="d-flex align-items-center justify-content-between pb-2 mb-3 border-bottom">
                    <div class="quill-tool">
                    </div>
                  </div>
                  <div id="quill-toolbar1">
                    <p>Virtual Digital Marketing Course every week on Monday, Wednesday and Saturday.Virtual Digital Marketing Course every week on Monday</p>
                  </div>
                </div>
                <div class="card-footer border-0">
                  <div class="d-flex flex-wrap align-items-ceter justify-content-end">
                    <div class="btn btn-primary mr-3" data-dismiss="modal">Cancel</div>
                    <div class="btn btn-outline-primary" data-dismiss="modal">Save</div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<style scoped>
.align-items-left{
  text-align: left;
}
</style>